using System;
using System.Collections.Generic;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class Character
    {
        public string name;
        public int[] jobLV;  //[3]
        public int currentJob;
        public string[] jobName; //[3]
        public int MaxHP, HP, MaxMP, MP;
        public int Str, Mag, Agi, Def, MDef, Learn, Style;
        public double[] jobStr, jobMag, jobAgi, jobDef, jobMDef, jobLearn, jobStyle, jobMaxHP, jobMaxMP;
        public int XP;
        public string[] acc; //what accessories are equipped 3
        public string[] guide; //3
        public int accMax, guideMax; //how many accessories & guides can be equipped
        public string race; //Living, Undead, Mech
        public int fireRes, coldRes, earthRes, airRes;
        //public int[] weaponDam; //3 array
        //public int[] weaponType; //0 = Str-based, 1=Mag-based, 2=flat  3 in array
        //public string weaponName;
        public Character()
        {
            name = "";
            jobLV = new int[3];
            jobName = new string[3];
            acc = new string[3];
            guide = new string[3];
            jobStr = new double[4]; jobMag = new double[4]; jobAgi = new double[4]; jobDef = new double[4]; jobMDef = new double[4];
            jobLearn = new double[4]; jobStyle = new double[4]; jobMaxHP = new double[4]; jobMaxMP = new double[4];
            //weaponDam = new int[3];
            //weaponType = new int[3];

            for (int x = 0; x < 3; x++)
            {
                jobLV[x] = 0;
                jobName[x] = "";
                acc[x] = "";
                guide[x] = "";
                //weaponDam[x] = 0;
                //weaponType[x] = 0;
            }
            for (int x = 0; x<4; x++)
            {
                jobStr[x] = 0; jobMag[x] = 0; jobAgi[x] = 0; jobDef[x] = 0; jobMDef[x] = 0;
                jobLearn[x] = 0; jobStyle[x] = 0; jobMaxHP[x] = 0; jobMaxMP[x] = 0;
            }
            currentJob = 0;
            MaxHP = 0; HP = 0; MaxMP = 0; MP = 0;
            Str = 0; Mag = 0; Agi = 0; Def = 0; MDef = 0; Learn = 0; Style = 0;
            XP = 0; accMax = 0; guideMax = 0; race = "";
            fireRes = 100; coldRes = 100; earthRes = 100; airRes = 100;
            //weaponName = "";
        }
        public void letsTest()
        {
            name = "Molly";
            HP = 350; MaxHP = 400; MP = 100; MaxMP = 150;
            XP = 5;
        }

        public void InitiateChar(string theName, int theXP, int jobALV, int jobBLV, int jobCLV)
        {
            name = theName;
            XP = theXP;
            jobLV[0] = jobALV;
            jobLV[1] = jobBLV;
            jobLV[2] = jobCLV;
            switch (name)
            {
                case "Molly": race = "Undead";
                    jobName[0] = "Werewolf"; jobMaxHP[0] = 7.5; jobMaxMP[0] = 5; jobStr[0] = 4; jobMag[0] = 2.5; jobDef[0] = 2.5; jobMDef[0] = 2.5; jobLearn[0] = 2; jobStyle[0] = 2.5; jobAgi[0] = 2.5;
                    jobName[1] = "Zombie"; jobMaxHP[1] = 12; jobMaxMP[1] = 5; jobStr[1] = 3; jobMag[1] = 2; jobDef[1] = 2.5; jobMDef[1] = 2; jobLearn[1] = 2; jobStyle[1] = 2.5; jobAgi[1] = 2;
                    jobName[2] = "Vampire"; jobMaxHP[2] = 7.5; jobMaxMP[2] = 8; jobStr[2] = 2; jobMag[2] = 3; jobDef[2] = 2; jobMDef[2] = 2.5; jobLearn[2] = 3; jobStyle[2] = 2.5; jobAgi[2] = 2.5;
                    break;
                case "Sirak": race = "Living";
                    jobName[0] = "Alley Cat"; jobMaxHP[0] = 7.5; jobMaxMP[0] = 4; jobStr[0] = 2.5; jobMag[0] = 2; jobDef[0] = 2; jobMDef[0] = 2; jobLearn[0] = 2; jobStyle[0] = 1; jobAgi[0] = 4;
                    jobName[1] = "Kitty"; jobMaxHP[1] = 6; jobMaxMP[1] = 8; jobStr[1] = 1; jobMag[1] = 3; jobDef[1] = 1.5; jobMDef[1] = 3; jobLearn[1] = 2.5; jobStyle[1] = 1.5; jobAgi[1] = 2.5;
                    jobName[2] = "Black Cat"; jobMaxHP[2] = 4.5; jobMaxMP[2] = 6; jobStr[2] = 1.5; jobMag[2] = 3; jobDef[2] = 1.5; jobMDef[2] = 2.5; jobLearn[2] = 3; jobStyle[2] = 1; jobAgi[2] = 2;
                    break;
            }
            InitiateStats();
            HP = MaxHP;
            MP = MaxMP;
        }

        public void InitiateStats()
        {
            int numJobs;
            if (jobLV[2] == 0)
                numJobs = 2;
            else
                numJobs = 3;

            double[] balance = new double[3];
            for (int x = 0; x < 3; x++)
            {
                balance[x] = 0.5;
            }

            switch (numJobs) //determine the weight to give each job's stats
            {
                case 2:
                    if (jobLV[0] == jobLV[1])
                    {
                        balance[0] = 0.75;
                        balance[1] = 0.75;
                    }
                    if (jobLV[0] > jobLV[1])
                        balance[0] = 1;
                    if (jobLV[1] > jobLV[0])
                        balance[1] = 1;
                    break;
                case 3:
                    if (jobLV[0] == jobLV[1] & jobLV[0] == jobLV[2])
                    {
                        balance[0] = 0.67;
                        balance[1] = 0.67;
                        balance[2] = 0.67;
                    }
                        if (jobLV[0] == jobLV[1] & jobLV[0] > jobLV[2])
                        {
                            balance[0] = 0.75;
                            balance[1] = 0.75;
                        }
                        if (jobLV[0] == jobLV[2] & jobLV[0] > jobLV[1])
                        {
                            balance[0] = 0.75;
                            balance[1] = 0.75;
                        }
                        if (jobLV[1] == jobLV[2] & jobLV[1] > jobLV[0])
                        {
                            balance[1] = 0.75;
                            balance[2] = 0.75;
                        }
                        if (balance[0] == 0.5 & balance[1] == 0.5 & balance[2] == 0.5)
                        {
                            if (jobLV[0] > jobLV[1] & jobLV[0] > jobLV[2])
                                balance[0] = 1;
                            if (jobLV[1] > jobLV[0] & jobLV[1] > jobLV[2])
                                balance[1] = 1;
                            if (jobLV[2] > jobLV[0] & jobLV[2] > jobLV[0])
                                balance[2] = 1;
                        }
                    break;
            }
            //test
            //balance[1] = 1; balance[0] = 1; balance[2] = 1;

            jobMaxHP[3] = 0; jobMaxMP[3] = 0; jobStr[3] = 0; jobMag[3] = 0; jobDef[3] = 0; jobMDef[3] = 0; jobLearn[3] = 0; jobStyle[3] = 0; jobAgi[3] = 0;
            for (int x = 0; x<numJobs; x++){
                jobMaxHP[3] = jobMaxHP[3] + (jobLV[x] * jobMaxHP[x] * balance[x]);
                jobMaxMP[3] = jobMaxMP[3] + (jobLV[x] * jobMaxMP[x] * balance[x]);
                jobStr[3] = jobStr[3] + (jobLV[x] * jobStr[x] * balance[x]);
                jobMag[3] = jobMag[3] + (jobLV[x] * jobMag[x] * balance[x]);
                jobDef[3] = jobDef[3] + (jobLV[x] * jobDef[x] * balance[x]);
                jobMDef[3] = jobMDef[3] + (jobLV[x] * jobMDef[x] * balance[x]);
                jobLearn[3] = jobLearn[3] + (jobLV[x] * jobLearn[x] * balance[x]);
                jobStyle[3] = jobStyle[3] + (jobLV[x] * jobStyle[x] * balance[x]);
                jobAgi[3] = jobAgi[3] + (jobLV[x] * jobAgi[x] * balance[x]);
            }
            MaxHP = System.Convert.ToInt32(Math.Floor(jobMaxHP[3]));
            MaxMP = System.Convert.ToInt32(Math.Floor(jobMaxMP[3]));
            Str = System.Convert.ToInt32(Math.Floor(jobStr[3]));
            Mag = System.Convert.ToInt32(Math.Floor(jobMag[3]));
            Def = System.Convert.ToInt32(Math.Floor(jobDef[3]));
            MDef = System.Convert.ToInt32(Math.Floor(jobMDef[3]));
            Learn = System.Convert.ToInt32(Math.Floor(jobLearn[3]));
            Style = System.Convert.ToInt32(Math.Floor(jobStyle[3]));
            Agi = System.Convert.ToInt32(Math.Floor(jobAgi[3]));
        }

        public void Reset()
        {
            name = "";
        }
    }
}