using System;
using System.Collections.Generic;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class TextBox
    {
        //public string myText;
        public int myX1, myY1, myX2, myY2;
        //public int type; //what type of box
        //public int onScreen; //0=visible, 1=not
        public string[] text; //8 array what text is given to the system to sort
        public string[] line; //20 array what's actually on screen  117
        public int lastSpace;
        public int startText;
        public int startSpot;
        public int endText;
        public int endSpot;
        public int maxLines; //double
        public int pressA;
        public int startLine;

        public void Determine(int mode, int page){
            switch (mode)  //This is where we put all of our text box text!
            {
                case 0: switch (page) //Main menu switch
                { 
                    case 0: //Title Screen Message
                        Change(@"""My name is Molly.  This is my story.""", "Welcome to the Molly the Were-Zompire RPG.  Created by Robert Boyd.", "Controls: Use the D-Pad to select an option.  The A button confirms a choice, the B button cancels.");
                        break;
                    case 1: //If you begin
                        Change("Let's begin!");
                        break;
                    case 2: //If you continue 
                        //Change("Let's continue!");
                        Change("Far out in the uncharted backwaters of the unfashionable end of the western spiral arm of the Galaxy lies a small unregarded yellow sun.", "Orbiting this at a distance of roughly ninety-two million miles is an utterly insignificant little blue green planet whose ape- descended life forms are so amazingly primitive that they still think digital watches are a pretty neat idea.", "This planet has - or rather had - a problem, which was this: most of the people on it were unhappy for pretty much of the time. Many solutions were suggested for this problem, but most of these were largely concerned with the movements of small green pieces of paper, which is odd because on the whole it wasn't the small green pieces of paper that were unhappy.", "And so the problem remained; lots of the people were mean, and most of them were miserable, even the ones with digital watches.", "Many were increasingly of the opinion that they'd all made a big mistake in coming down from the trees in the first place. And some said that even the trees had been a bad move, and that no one should ever have left the oceans.", "And then, one Thursday, nearly two thousand years after one man had been nailed to a tree for saying how great it would be to be nice to people for a change, one girl sitting on her own in a small cafe in Rickmansworth suddenly realized what it was that had been going wrong all this time, and she finally knew how the world could be made a good and happy place. This time it was right, it would work, and no one would have to get nailed to anything.", "Sadly, however, before she could get to a phone to tell anyone about it, a terribly stupid catastrophe occurred, and the idea was lost forever.", "This is not her story. Far out in the uncharted backwaters of the unfashionable end of the western spiral arm of the Galaxy lies a small unregarded yellow sun. Far out in the uncharted backwaters of the unfashionable end of the western spiral arm of the Galaxy lies a small unregarded yellow sun.");
                        break;
                    case 3:
                        Change("Let's press A!");
                        pressA = 1;
                        break;
                    default: break;
                }
                    break;
                default: break;
            }
        }
        public TextBox()
        {
            //myText = "";
            text = new string[8];
            line = new string[117]; //20
            for (int x = 0; x < 8; x++)
            {
                text[x] = "";
            }
            for (int x = 0; x < 117; x++)
            {
                line[x] = "";
            }
            lastSpace = 0;
            startText = 0;
            startSpot = 0;
            endText = 0;
            endSpot = 0;
            maxLines = 0;
            myX1 = 0;
            myX2 = 0;
            myY1 = 0;
            myY2 = 0;
            //onScreen = 0;
            //type = 0;
            pressA = 0;
            startLine = 0;
        }
        //public TextBox(string text, int x1, int y1, int x2, int y2)
        public void ResetBox()
        {
            for (int x = 0; x < 8; x++)
            {
                text[x] = "";
            }
            for (int x = 0; x < 117; x++)
            {
                line[x] = "";
            }
            lastSpace = 0;
            startText = 0;
            startSpot = 0;
            endText = 0;
            endSpot = 0;
            maxLines = 0;
            myX1 = 0;
            myX2 = 0;
            myY1 = 0;
            myY2 = 0;
            //onScreen = 0;
            //type = 0;
            pressA = 0;
            startLine = 0;
        }

        public void SetXY()
        {
            myX1 = 40;
            myX2 = 800;
            myY1 = 25;
            myY2 = 440;
        }
        // int x1, int y1, int x2, int y2,             
        // myX1 = x1;
        //    myX2 = x2;
        //    myY1 = y1;
        //    myY2 = y2;
        public void Change(string textA, string textB, string textC, string textD, string textE, string textF, string textG, string textH)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = textC;
            text[3] = textD;
            text[4] = textE;
            text[5] = textF;
            text[6] = textG;
            text[7] = textH;
            SetXY();
        }
        public void Change(string textA, string textB, string textC, string textD, string textE, string textF, string textG)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = textC;
            text[3] = textD;
            text[4] = textE;
            text[5] = textF;
            text[6] = textG;
            text[7] = "";
            SetXY();
        }
        public void Change(string textA, string textB, string textC, string textD, string textE, string textF)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = textC;
            text[3] = textD;
            text[4] = textE;
            text[5] = textF;
            text[6] = "";
            text[7] = "";
            SetXY();
        }
        public void Change(string textA, string textB, string textC, string textD, string textE)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = textC;
            text[3] = textD;
            text[4] = textE;
            text[5] = "";
            text[6] = "";
            text[7] = "";
            SetXY();
        }
        public void Change(string textA, string textB, string textC, string textD)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = textC;
            text[3] = textD;
            text[4] = "";
            text[5] = "";
            text[6] = "";
            text[7] = "";
            SetXY();
        }
        public void Change(string textA, string textB, string textC)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = textC;
            text[3] = "";
            text[4] = "";
            text[5] = "";
            text[6] = "";
            text[7] = "";
            SetXY();
        }
        public void Change(string textA, string textB)
        {
            ResetBox();
            text[0] = textA;
            text[1] = textB;
            text[2] = "";
            text[3] = "";
            text[4] = "";
            text[5] = "";
            text[6] = "";
            text[7] = "";
            SetXY();
        }
        public void Change(string textA)
        {
            ResetBox();
            text[0] = textA;
            text[1] = "";
            text[2] = "";
            text[3] = "";
            text[4] = "";
            text[5] = "";
            text[6] = "";
            text[7] = "";
            SetXY();
        }
    }
}