using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class Battle
    {
        public string[] monster;
        public bool completed;
        public int reward;
        /*Rewards
         * 0 = Boss Fight, no Reward.
         * 1 = Stun all enemies 1st Round
         * 2 = Double Damage Darkness
         * 3 = Recover all MP
         * 4 = Defense + 5
         * 5 = Regular Attack targets all.

        */
        public Battle()
        {
            Reset();
        }
        public void Reset()
        {
            monster = new string[5];
            for (int x = 0; x < 5; x++)
            {
                monster[x] = "";
            }
            completed = false;
        }
        public void AddMonsters(int x, string a)
        {
            Reset();
            reward = x;
            monster[0] = a;
        }
        public void AddMonsters(int x, string a, string b)
        {
            Reset();
            reward = x;
            monster[0] = a;
            monster[1] = b;
        }
        public void AddMonsters(int x, string a, string b, string c)
        {
            Reset();
            reward = x;
            monster[0] = a;
            monster[1] = b;
            monster[2] = c;
        }
        public void AddMonsters(int x, string a, string b, string c, string d)
        {
            Reset();
            reward = x;
            monster[0] = a;
            monster[1] = b;
            monster[2] = c;
            monster[3] = d;
        }
        public void AddMonsters(int x, string a, string b, string c, string d, string e)
        {
            Reset();
            reward = x;
            monster[0] = a;
            monster[1] = b;
            monster[2] = c;
            monster[3] = d;
            monster[4] = e;
        }
        public string RewardDesc(int x)
        {
            string temp = "";
            switch (x)
            {
                case 0: temp = "None";
                    break;
                case 1: temp = "All enemies begin the battle stunned.";
                    break;
                case 2: temp = "Darkness attacks deal double damage.";
                    break;
                case 3: temp = "Recover all MP at the beggining of battle.";
                    break;
                case 4: temp = "All allies begin with +5 to Defense.";
                    break;
                case 5: temp = "Your regular attacks target all enemies.";
                    break;
                default:
                    break;
            }
            return "Power-Up: " + temp;
        }
    }
}