using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class Attack
    {
        public string name;
        public string type;  //0 = Physical, 1=Magical, 2=Ignore Defense
        public string element; //Which element or "None"
        public int power; //How much damage
        //public bool good; //If false, it's an enemy's attack.  If true, it's an ally's.
        public int posTarget; //1 - One enemy, 2 - One ally, 10 - All enemies, 20 - All allies. 0 - Special
        public int target; //0-3, 0-4, 10 = all
        public int special; //Any special effects.
        public int MPCost;

        public Attack()
        {
            Reset();
        }

        public void SetUp(string nam, int posT, string phys, string ele, int pow, int cost)
        {
            Reset();
            name = nam;
            posTarget = posT;
            type = phys;
            element = ele;
            power = pow;
            //special = speci;
            MPCost = cost;
            //target = targe;
        }

        public void Reset()
        {
            name = "";
            type = "Physical";
            element = "None";
            power = 0;
            //good = true;
            posTarget = 0;
            target = 100; //This equals no target
            special = 0;
            MPCost = 0;
        }

    }
}