using System;
using System.Collections.Generic;
using System.Text;

namespace Molly_the_Were_Zompire_RPG
{
    class sys
    {
        public bool pictureDone;
        public int visibleText; //0 means visible
        public int visibleMenu;
        public int visibleCharMenu;  //0 = not, 1 = enemy, 2 = living allies, 3 = dead allies
        public int visibleChar;
        public int visibleEnemy;
        public int visibleTitle; //# of visible titles
        public int buttonX, buttonY; //what do X & Y do right now?  0 = nothing.
        //public int pressA;
        public int message;
        public int finishMessage;
        public int page;
        //public int mode;
        public string mode; //Main Menu
        public string subMode;  //
        public int stage; 
        public int refreshMode;
        public int StatusMode; //0 = normal, 1 = Ally stats, 2 = enemy stats
        public int StatusPage; //Which page of stat
        public int whichmenu;
        public string whichMessage;
        //For Battles
        public int round; //Which round of combat are we doing?
        public int totalRounds; //We keep track of this for scoring
        public int[] turn; //Each characters order 0 = Dead, 1=First  1000=Sorting  [0-3] = Player characters, [4-8] = Monsters
        public int currentTurn; //Whose turn are we doing now? 100 = all done
        public int reward; //Which power-up do we have?
        public int whichBattle; //which Battle are we fighting?
        public int extraLives; //How many extra lives do we have left?
        public string BattleMode; //Which part of the battle code are we using?
        //public Boolean Initialize;
        public int initialize;
        public int BattleMenu;
        public int endlessnight;
        public string description; //What kind of description do we need for help text?
        public string difficulty;
        public int controller; //Which controller is being used?  100 = None
        public static int[] score; //0-19 = Normal, 20-39 = Hard
        public int[] path;
        public int currentpath;
        public int[] storyLength;
        public bool backtrack;
        public bool fastforward;
        public int background;
        public string[] choices;
        public int currentsong;
        public int newSong;
        public bool musicOn;
        public bool pressedBack;
        //public bool[] CompBattles;  //Which battles are completed

        public sys()
        {
            pictureDone = false;
            pressedBack = false;
            musicOn = true;
            currentsong = 0;
            newSong = 0;
            fastforward = false;
            background = 0;
            BattleMenu = 0;
            initialize = 0;
            description = "";
            round = 0;
            totalRounds = 0;
            turn = new int[9];
            score = new int[40];
            backtrack = false;
            choices = new string[3];
            for (int x = 0; x < 3; x++)
            {
                choices[x] = "";
            }

            for (int x = 0; x < 40; x++)
            {
                score[x] = 0;
            }
            for (int x = 0; x < 9; x++)
            {
                turn[x] = 0;
            }

            path = new int[150];
            storyLength = new int[150];
            for (int x = 0; x<150; x++)
            {
                path[x] = 9999;
                storyLength[x] = 0;
            }
            currentpath = 0;

            //CompBattles = new bool[5];
            //for (int x = 0; x < 5; x++)
            //{
            //    CompBattles[x] = false;
            //}
            currentTurn = 0;
            reward = 0;
            extraLives = 0;
            whichBattle = 0;
            whichMessage = "";
            BattleMode = "";

            message = 0;
            finishMessage = 0;
            visibleText = 0;
            visibleMenu = 0;
            visibleChar = 0;
            visibleCharMenu = 0;
            visibleEnemy = 0;
            mode = "";
            subMode = "";
            visibleTitle = 0;
            buttonX = 0;
            buttonY = 0;
            StatusMode = 0;
            StatusPage = 0;
            refreshMode = 0;
            stage = 0;
            page = 0;
            whichmenu = 0;
            endlessnight = 0;
            difficulty = "Normal";
            controller = 100;
        }
    }
}